using System;
using System.Data;
using System.Data.SqlClient;

namespace CollectorCompLib
{
	/// <summary>
	/// Summary description for Collector.
	/// </summary>
	public class Collector
	{
		private readonly string dbconnection = System.Configuration.ConfigurationSettings.AppSettings["DBConnectionString"].ToString();

		private int id;
		private int count;
		private bool bigCollector;

		public int collectorID
		{
			get { return id; }
		}

		public int collectionCount
		{
			get { return count; }
		}

		protected internal Collector() {} // You must use the Factory to get Collector

		private void init(int theID, int itemsCount, bool big)
		{
			id = theID;
			count = itemsCount;
			bigCollector = big;
		}

		protected internal virtual void load(int theID)
		{
			SqlConnection connection = new SqlConnection(dbconnection);
			SqlCommand command = connection.CreateCommand();
			command.CommandText = "SELECT * from collectors where [id] = " + theID;
			connection.Open();
			SqlDataReader reader = command.ExecuteReader();

			if (reader.Read())
			{
				init(Convert.ToInt32(reader["id"]),
					Convert.ToInt32(reader["items_count"]),
					Convert.ToBoolean(reader["big_collector"]));
			}
			else
				throw new ApplicationException("Invalid id");

			connection.Close();
		}

		public void buy(int numberOfItems)
		{
			if (bigCollector && numberOfItems < 1000)
				throw new ApplicationException("That's too small for me to buy");
			else
			{
				count += numberOfItems;
				save();
			}
		}

		public void sell(int numberOfItems)
		{
			if (count < numberOfItems)
				throw new ApplicationException("Not enough items to sell");
			else
			{
				count -= numberOfItems;
				save();
			}
		}

		protected virtual void save()
		{
			SqlConnection connection = new SqlConnection(dbconnection);
			SqlCommand command = connection.CreateCommand();
			connection.Open();
			command.CommandText = "UPDATE collectors SET items_count = " +
				count + " where [id] = " + collectorID;

			command.ExecuteNonQuery();
		}
	}
}
